"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getPluginProps = exports.generateValidationMessage = exports.ResponseTypes = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var ResponseTypes = {
  advanced: 'Advanced Multi',
  simple: 'Simple'
};
exports.ResponseTypes = ResponseTypes;

var generateValidationMessage = function generateValidationMessage() {
  var model = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var maxResponseAreas = config.maxResponseAreas;
  var responseType = model.responseType;
  var responseAreasMessage = '';
  var answersMessage = '\nAll correct answers (the primary and any alternates) should not be empty and should be unique.';

  if (responseType === 'Advanced Multi') {
    responseAreasMessage = '\nThere should be at least 1 ' + (maxResponseAreas ? "and at most ".concat(maxResponseAreas, " ") : '') + 'response area' + (maxResponseAreas ? 's' : '') + ' defined.';
  }

  return 'Validation requirements:' + answersMessage + responseAreasMessage;
};

exports.generateValidationMessage = generateValidationMessage;

var getPluginProps = function getPluginProps() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var baseInputConfiguration = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return _objectSpread(_objectSpread({}, baseInputConfiguration), props);
};

exports.getPluginProps = getPluginProps;
//# sourceMappingURL=utils.js.map